// バーの位置
float angle = 0.0f;             // 角度。右回りが正方向
// プレイヤー
int smoothness = 3;             // [設定]移動のゆるさ
float x = 0.0f;                 // バーに沿った位置
// 背景画像
String bgFile = "bg01.jpg";     // [設定]画像ファイル名
PImage bgImage;                 // 画像データ
// 得点関連
String ballFile = "ball.bmp";   // [設定]画像ファイル名
int ballSize = 30;              // [設定]サイズ
int score = 0;                  // 現在の得点
int emitSpan = 60;              // 次の得点が降ってくるまでの時間
PImage ballImage;               // 画像データ
ArrayList balls = new ArrayList(); // 表示中の得点オブジェクト

void setup() {
  size(480, 480);
  frameRate(60);
  textFont(loadFont("Arial-Black-48.vlw"));
  smooth();
  strokeWeight(3);
  bgImage = loadImage(bgFile);
  bgImage.resize(width, height);
  ballImage = loadImage(ballFile);
  clearBackground(ballImage);
  ballImage.resize(ballSize, ballSize);
}

void draw() {
  // バーの中心座標
  int ox = width / 2;
  int oy = height * 3 / 4;
  // バーの長さの半分
  int len = width / 2;
  float cosa = cos(angle);
  float sina = sin(angle);
  
  if (keyPressed) {
    if (key == 'z') {
      angle -= 0.03f;
    } else if (key == 'x') {
      angle += 0.03f;
    }
  }
  if (--emitSpan < 0) {
    emit();
    emitSpan = (int)random(120) + 60;
  }
  x += smoothness * angle;
  if (x < -width / 2) { x = -width / 2; }
  else if (x > width / 2) { x = width / 2; }
  float playerX = ox + x * cosa;
  float playerY = oy + x * sina;
  
  for (int i = balls.size() - 1; i >= 0; i--) {
    Ball ball = (Ball)balls.get(i);
    ball.step(1.0f / 60);
    float dx = ball.x - playerX;
    float dy = ball.y - playerY;
    if (dx * dx + dy * dy < 20 * 20) {
      score += 10;
      balls.remove(i);
    }
    if (ball.y > height) {
      balls.remove(i);
    }
  }
  
  background(bgImage);
  
  for (int i = balls.size() - 1; i >= 0; i--) {
    ((Ball)balls.get(i)).draw();
  }
  line(ox, oy, ox + len * cosa, oy + len * sina);
  line(ox, oy, ox - len * cosa, oy - len * sina);
  ellipse(playerX, playerY, 30, 30);
  text("SCORE: " + score, 0, 60);
}

void emit() {
  balls.add(new Ball(random(width), 0));
}

void clearBackground(PImage image) {
  int size = image.width * image.height;
  int[] mask = new int[size];
  color white = color(255, 255, 255);
  image.loadPixels();
  for (int i = 0; i < size; i++) {
    if (image.pixels[i] == white) {
      mask[i] = 0;
    } else {
      mask[i] = 255;
    }
  }
  image.mask(mask);
}

class Ball {
  float x, y;
  Ball(float x, float y) {
    this.x = x;
    this.y = y;
  }
  void step(float dt) {
    y += dt * 200;
  }
  void draw() {
    image(ballImage, x - ballSize / 2, y - ballSize / 2);
  }
}

